import processing.core.*; 
import processing.xml.*; 

import com.twitter.processing.*; 
import processing.opengl.*; 
import peasy.*; 
import javax.media.opengl.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class TwitterViz extends PApplet {

//
// Visualisation Project for MAT259
// Look at the emotions displayed on Twitter in Realtime
// Twitter accessed using Mark McBride's Twitter Library for Processing
// Tweets categorised into the 6 basic emotions and then displayed in 3D
// using traer physics and SuperPoint
//
// Ben Alun-Jones
// March 13th 2010






int tweets;
PeasyCam cam;
PGraphicsOpenGL pgl;
GL gl;
PImage love; 
PImage anger; 
PImage surp; 
PImage joy; 
PImage sad; 
PImage fear;
PImage logo;
PImage ProfilePic;
String ProfileText;
String username;
int CurProfile = 0;
int NTweets = 50;

public static final int LOVE = 0;
public static final int JOY = 1;
public static final int SURPRISE = 2;
public static final int ANGER = 3;
public static final int SADNESS = 4;
public static final int FEAR = 5;
double count =0;

boolean display = false;
boolean rotation = true;
boolean spherical = true;

ArrayList Emotions;

PFont font;
PGraphics buffer;   // buffer

public void setup(){
  size(1200,800,OPENGL);
  hint(DISABLE_OPENGL_2X_SMOOTH);
  hint(ENABLE_OPENGL_4X_SMOOTH); 
  //hint(ENABLE_DEPTH_SORT);

  love = loadImage("love.png"); 
  joy = loadImage("joy.png");
  anger = loadImage("anger.png");
  sad = loadImage("sad.png");
  surp = loadImage("surprise.png");
  fear = loadImage("fear.png");
  logo = loadImage("twitter.png");
  
  // set up font
  font = loadFont("AppleCasual-48.vlw");
  textFont(font, 36);
  
  Emotions = new ArrayList();
  
  TweetStream stream = new TweetStream(this, "stream.twitter.com", 80, "1/statuses/sample.json", "mister_benjamin", "editors25");
  stream.go();
  
  cam = new PeasyCam(this,0,0,0, 800);
  cam.setMinimumDistance(0.0000001f);
  cam.setMaximumDistance(5000);
}

public void draw(){
  imageMode(CENTER); 
  background(0xffEDFEFF);
  
  pgl = (PGraphicsOpenGL) g;
  gl = pgl.gl;

    // This fixes the overlap issue
  gl.glDepthMask(false); 
//  gl.glDisable(GL.GL_DEPTH_TEST);
  
  gl.glClear(GL.GL_DEPTH_BUFFER_BIT); 
  // Turn on the blend mode
  gl.glEnable(GL.GL_BLEND);
  // Define the blend mode
  gl.glBlendFunc(GL.GL_SRC_ALPHA,GL.GL_SRC_ALPHA_SATURATE);
  
//  gl.glEnable (GL.GL_LINE_SMOOTH);
//  gl.glHint (GL.GL_LINE_SMOOTH_HINT, GL.GL_NICEST);

//  pgl.beginGL();
  fill(10, 60, 120);

  if(Emotions.size()>1 && display){
    if(frameCount%20 == 10){
      CurProfile = floor(random(0,Emotions.size()-1));
      println("update");
    }
    Emotion pictureman = (Emotion)Emotions.get(CurProfile);
    if(pictureman.getImURL() != null && pictureman.getTweetText() != null){
      ProfilePic = loadImage(pictureman.getImURL());
      ProfileText = pictureman.getTweetText();
      username = pictureman.getUserName();
    }
  }
  
  boolean plot;
  for(int i = 0; i< Emotions.size();i++){
    
    plot = true;
    Emotion this_feeling = (Emotion)Emotions.get(i);
    
    float[] positions = cam.getPosition(); 
    
    pushMatrix();
    
    float 
      theta = 0f,
      radius = 0f,
      phi = 0f;
      
    try{
    theta = this_feeling.userid;//map(this_feeling.userid, 0,100000000, 0,100);
    radius = log(this_feeling.nUpdates)*40;//MAP(this_feeling.nUpdates,0,100, 0,800); 
    phi = this_feeling.nFollowers/10;
    }
    catch(Exception e){
      println(e.getMessage());
      plot = false;
    }
    
    PVector cam_position = new PVector(positions[0],positions[1],positions[2]);
    PVector new_loc;
    if(spherical){
      new_loc = new PVector(radius*sin(theta)*cos(phi),radius*sin(theta)*sin(phi), radius*cos(theta));
    }
    else{
      new_loc = new PVector(this_feeling.userid/100000,this_feeling.nUpdates/100 , this_feeling.nFollowers/10);
    }
    PVector camUP = new PVector(0,0,1);

    stroke(0xff71DAF7,120);
    strokeWeight(2);
    line(0,0,0,new_loc.x, new_loc.y, new_loc.z);

    translate(new_loc.x, new_loc.y, new_loc.z);
//    strokeWeight(log(this_feeling.nFriends)*4);//*frameRate%2);
    
    PVector objToCamProj = PVector.sub(cam_position , new_loc); 
    objToCamProj.normalize(); 
    
    PVector bill_right = objToCamProj.cross(camUP);
    bill_right.normalize(); 
    
    PVector bill_up = objToCamProj.cross(bill_right);

    applyMatrix(bill_right.x,  bill_up.x,  objToCamProj.x,  0,
                bill_right.y,  bill_up.y,  objToCamProj.y,  0,
                bill_right.z,  bill_up.z,  objToCamProj.z,  0,
                0,             0,          0,               1); 

    float size = 0f;
    strokeWeight(1);
    if(plot){
      switch(this_feeling.Emo){
        
        case 0 : // LOVE
        int love_tint = 0xffF32973;
        tint(love_tint,150);
        size = (log(this_feeling.nFriends)/40)*love.width;
        image(love,0,0,size,size); 
        fill(0,0);
        stroke(love_tint);
        ellipse(0,0,size, size);
        break;
        
        
        case 1 : // JOY
        int joy_tint = 0xffFFF824;
        fill(joy_tint,190);
        stroke(joy_tint);
        size = (log(this_feeling.nFriends)/40)*joy.width;
        ellipse(0,0,size, size);
        tint(joy_tint,150);
        image(joy,0,0,size,size); 
        break;
        
        case 2 : //SURPRISE
        int surp_tint = 0xff48EE06;//#FC913A;//#72DE1F;
        tint(surp_tint,150);
        size = (log(this_feeling.nFriends)/40)*surp.width;
        image(surp,0,0,size,size); 
        fill(0,0);
        stroke(surp_tint);
        ellipse(0,0,size,size);
        break;
        
        case 3 : //ANGER
        int anger_tint = 0xffEE0909;//#B1142B;
        tint(anger_tint,150);
        size = (log(this_feeling.nFriends)/40)*anger.width;
        image(anger,0,0,size,size); 
        fill(0,0);
        stroke(anger_tint);
        ellipse(0,0,size,size);
        break;
        
        case 4 : //SADNESS
        int sad_tint = 0xff4B72F2;
        tint(sad_tint,250);
        image(sad,0,0,(log(this_feeling.nFriends)/40)*sad.width,(log(this_feeling.nFriends)/40)*sad.height); 
        fill(sad_tint,100);
        stroke(sad_tint);
        size = (log(this_feeling.nFriends)/40)*sad.width;
        ellipse(0,0,size,size);
        break;
        
        case 5 : //FEAR
        int fear_tint = 0xffC0C0D8;
        tint(fear_tint,250);
        size = (log(this_feeling.nFriends)/40)*fear.width;
        image(fear,0,0,size,size); 
        fill(fear_tint,150);
        stroke(fear_tint);
        ellipse(0,0,size,size);
        break;
      }
    }
    popMatrix();
//    pgl.endGL();
    fill(255,0);
    stroke(120,20);
    strokeWeight(1);
    
    if(rotation){
      cam.setRotations(count,-count,count);
      count = (count-random(0,0.0001f));
    }
  
  }
 // pgl.endGL();
  hud();
  
  while(Emotions.size() >NTweets){
    Emotions.remove(0);
  }
}



public void hud() {
  //Display HUD using PeasyCam
  cam.beginHUD();
  // Draw in edges
  fill(0xff71DAF7);
  stroke(0,0);
  strokeCap(ROUND);

  rect(0,0,100,height);
  rect(width-100,0,100,height);
  rect(0,0,width,100);
  rect(0,height-100,width,100);
  //show edge of window with red line
  stroke(255,255);
  strokeWeight(3);
  fill(0,0);
  rect(100,100,width-200,height-200);
  
  tint(255,255);
  imageMode(CORNER);
  image(logo, 100,50, logo.width/10, logo.height/10);
  textFont(font, 36);
  textAlign(LEFT,LEFT);
  fill(255);
  text("Emotion Visualisation in Real Time", 230,85);
  textAlign(RIGHT,RIGHT);
  text("Ben Alun-Jones", width-100,height-65);
  textFont(font, 18);
  text("MAT 259 Information Visualisation", width-100,height-45);

  if(ProfilePic != null && display){
    fill(255,255);
    rectMode(CORNER);
    rect(100,height-90, 460,height-70); 
    fill(0xff71DAF7);
    strokeWeight(0);
    rect(90,height-10, 480,height); 
    tint(255,255);
    image(ProfilePic, 105,height - 70, 50,50);
    textAlign(LEFT,LEFT);
    textFont(font, 20);
    fill(0xff71DAF7);
    text( "Random Tweeted Emotion:", 105, height-75);
    textFont(font, 12);
    fill(0xff34375A);
    text(username,160, height-60);
    fill(0xff71DAF7);
   // if(ProfileText!= null){
      if(ProfileText!= null && ProfileText.length()>71){
        int linelength = 70; 
        String line1 = ProfileText.substring(0,linelength);
        String line2 = ProfileText.substring(linelength);
        text(line1,160, height-45);
        text(line2.trim(),160, height-30);
      }
      else{
        if(ProfileText!= null)
          text(ProfileText,160, height-45);
      }
   // }

  }
    cam.endHUD(); // always!
}

// called by twitter stream whenever a new tweet comes in
public void tweet(Status tweet) {

  Emotion feeling = new Emotion(tweet);
  if(feeling.isEmotion()){
    Emotions.add(feeling);
  }
  tweets += 1; 
}

public void keyPressed() {
//  if (key == 't') {
//    display = !display;
//  }
  
  if(key =='r'){
    rotation = !rotation;
  }
  if(key =='s'){
    spherical = !spherical;
  }
}


//
// Class for incoming tweets, determines if they are emotions and categorises them 
// General handler of data and parser
//
// Ben Alun-Jones
// March 13th 2010

class Emotion{
  
  //TwitterID
  Long userid;
  Long nFollowers;
  Long nFriends;
  //How much they use Twitter
  Long nUpdates;
  String Location;
  String tweetText;
  int Emo;
  boolean valid;
  String UserImageURL;
  String name;
  
  //constructor
  Emotion(Status tweet){
    User thisGuy = tweet.user();
    nFriends = thisGuy.friendsCount();
    nFollowers = thisGuy.followersCount();
    userid = thisGuy.id();
    nUpdates = thisGuy.statusesCount();
    valid = false;
    getEmotion(tweet.text());
    UserImageURL = thisGuy.profileBackgroundImageURL();
    name = thisGuy.name();
  }
  public void getEmotion(String tweetText){
    //tweetText = new RiString(tweeted);
    tweetText.toLowerCase();
    
    if(tweetText.indexOf("anger") != -1  || tweetText.indexOf("hate") != -1 ){
      Emo = ANGER;
      valid = true;
    } 
    if(tweetText.indexOf("joy")  != -1 || tweetText.indexOf("happy")  != -1 ){
      Emo = JOY;
      valid = true;
    }
    if(tweetText.indexOf("love")  != -1 ){
      Emo = LOVE;
      valid = true;
    }
    if(tweetText.indexOf("suprise") != -1 || tweetText.indexOf("surprise")  != -1 || tweetText.indexOf("shock")  != -1 ){
      Emo = SURPRISE;
      valid = true;
    }
    if(tweetText.indexOf("sad")  != -1 || tweetText.indexOf("upset")  != -1 ){
      Emo = SADNESS;
      valid = true;
    }
    if(tweetText.indexOf("fear")  != -1 || tweetText.indexOf("afraid")  != -1 ){
      Emo = FEAR;
      valid = true;
    }
    //if(valid) println(Emo);
  }
  
  public boolean isEmotion(){
    return valid;
  }
  
  public Long getUserID(){
    return userid;
  }
  
  public Long getNumFollowers(){
    return nFollowers;
  }
  
  public Long getNumFriends(){
    return nFriends;
  }

  public Long getNumUpdates(){
    return nUpdates;
  }
  public String getLocation(){
    return Location;
  }
  
  public String getTweetText(){
    return tweetText;
  }
  public int getEmotion(){
    return Emo;
  }
  
  public String getImURL(){
    return UserImageURL;
  }
  
  public String getUserName(){
    return name;
  }
  
//  // draw the cube in the buffer
//  public void drawBuffer(PGraphics buffer) {
//    color idColor = getColor(id);
//    buffer.fill(idColor);
//    drawCube(buffer);
//  }
// 
//  private void drawCube(PGraphics g) {
//    g.pushMatrix();
//      g.translate(x, y, z);
//      g.ellipse(w);
//    g.popMatrix();
//  }
  
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--hide-stop", "TwitterViz" });
  }
}
